!
! Version 04.06.2005 - A. Kohlmeyer  axel.kohlmeyer@theochem.ruhr-uni-bochum.de
!
! $Id: string_utils.f90,v 1.1 2005/06/04 11:31:54 qmmm Exp $
!

MODULE string_utils

  IMPLICIT NONE
  
  PRIVATE
  PUBLIC :: xstring
  
CONTAINS
  
SUBROUTINE xstring(string,ia,ie)
!     ==--------------------------------------------------------------==
!     == Give index of the first and last non-blank character         ==
!     == blank characters are " " and CHAR(9) (tab)                   ==
!     == more blank characters are char(13) (cr) and CHAR(10) (newl)  ==
!     == STRING (INPUT)                                               ==
!     == IA,IE  (OUTPUT)                                              ==
!     ==--------------------------------------------------------------==
  IMPLICIT NONE
!     Arguments
  CHARACTER (len=*), INTENT(IN) :: string
  INTEGER, INTENT(OUT)      :: ia,ie
!     Variables
  INTEGER slen,i

  slen= LEN( string )
  ia=1
  DO i=1,slen
     IF ( string(i:i) /= ' ' .AND. string(i:i) /= char(9)   & !tab character
          .AND. string(i:i) /= char(10)                     & !newline character
          .AND. string(i:i) /= char(13) ) THEN                !carriage return character
        ia=i
        EXIT
     END IF
  END DO

  ie=slen
  DO i=ia,slen
     IF(string(i:i) == ' ' .OR. string(i:i) == char(0)     & !\0 character
          .OR. string(i:i) == char(9) ) THEN                 !tab character
        ie=i-1
        EXIT
     END IF
  END DO

  RETURN
END SUBROUTINE xstring

END MODULE string_utils
